using bdAntifraude.db;
using bdAntifraude.dbcontext;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace SwaggerAntifraude.Controllers
{
    [ApiController]
    [Route("api/[controller]")]
    public class IDIOMASController : GenericoController<IDIOMAS, int>
    {
        public IDIOMASController()
           : base()
        {
        }

        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("GetWithIncludes/{id}")]
        public async Task<IActionResult> GetWithIncludes(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Consulta con Includes necesarios
                    var entity = await context.IDIOMAS
                    .Include(p => p.IDNIVELNavigation)
                    .Include(p => p.IDTIPOIDIOMANavigation)
                    .AsNoTracking()
                    .Where(p => p.IDPERSONA == id).ToListAsync();

                    // Verifica si la entidad no se encontró
                    if (entity == null)
                        return NotFound($"El puesto con ID {id} no fue encontrado.");

                    // Devuelve la entidad con las relaciones cargadas
                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
    }
}
